/********************************** (C) COPYRIGHT *******************************
 * File Name          : CH32V103UFI.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2014/09/09
 * Description        : USB-flash File Interface for CHRV3.
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 *******************************************************************************/
/* CHRV3 Uļϵͳӿ, ֧: FAT12/FAT16/FAT32 */

//#define DISK_BASE_BUF_LEN		512	/* ĬϵĴݻСΪ512ֽ(ѡΪ20484096֧ĳЩU),Ϊ0ֹڱļж建ӦópDISK_BASE_BUFָ */
/* ҪôݻԽԼRAM,ôɽDISK_BASE_BUF_LENΪ0Խֹڱļж建,ӦóڵCHRV3LibInit֮ǰõĻʼַpDISK_BASE_BUF */

//#define NO_DEFAULT_ACCESS_SECTOR	    1		/* ֹĬϵĴдӳ,бдĳ */
//#define NO_DEFAULT_DISK_CONNECT		1		/* ֹĬϵļӳ,бдĳ */
//#define NO_DEFAULT_FILE_ENUMER		1		/* ֹĬϵļöٻص,бдĳ */

#include "debug.h"
#include "CHRV3UFI.h"
#include "ch32v10x_usbhd_host.h"
#include "usb_host_config.h"

UINT8 USBHostTransact( UINT8 endp_pid, UINT8 tog, UINT32 timeout )
{
    uint8_t ret;
    ret = USBHDH_Transact( endp_pid, tog, timeout );
    return ret;
}

UINT8 HostCtrlTransfer( PUINT8 DataBuf, PUINT8 RetLen )
{
    uint8_t  ret;
    uint16_t retlen;
    retlen = (uint16_t)(*RetLen);
    ret = USBHDH_CtrlTransfer( RootHubDev.bEp0MaxPks, DataBuf, &retlen );
    return ret;
}

void CopySetupReqPkg( PCCHAR pReqPkt )
{
    uint8_t i;

    for(i = 0; i != sizeof(USB_SETUP_REQ); i++)
    {
        ((char *)pUSBHD_SetupRequest)[i] = *pReqPkt;
        pReqPkt++;
    }
}

UINT8 CtrlGetDeviceDescrTB( void )
{
    uint8_t ret;
    ret = USBHDH_GetDeviceDescr( &RootHubDev.bEp0MaxPks, TxBuffer );
    return ret;
}

UINT8 CtrlGetConfigDescrTB( void )
{
    uint16_t len;
    uint8_t  ret;
    ret = USBHDH_GetConfigDescr( RootHubDev.bEp0MaxPks, TxBuffer, 256, &len );
    return ret;
}

UINT8 CtrlSetUsbConfig( UINT8 cfg )
{
    uint8_t ret;
    ret = USBHDH_SetUsbConfig( RootHubDev.bEp0MaxPks, cfg );
    return ret;
}

UINT8 CtrlSetUsbAddress( UINT8 addr )
{
    uint8_t ret;
    ret = USBHDH_SetUsbAddress( RootHubDev.bEp0MaxPks, addr );
    return ret;
}

UINT8 CtrlClearEndpStall( UINT8 endp )
{
    uint8_t ret;
    ret = USBHDH_ClearEndpStall( RootHubDev.bEp0MaxPks, endp );
    return ret;
}

#ifndef FOR_ROOT_UDISK_ONLY
UINT8 CtrlGetHubDescr( void )
{

}

UINT8 HubGetPortStatus( UINT8 HubPortIndex )
{

}

UINT8 HubSetPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt )
{

}

UINT8 HubClearPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt )
{

}
#endif

CMD_PARAM_I	mCmdParam;						/*  */
#if		DISK_BASE_BUF_LEN > 0
//UINT8	DISK_BASE_BUF[ DISK_BASE_BUF_LEN ] __attribute__((at(BA_RAM+SZ_RAM/2)));	/* ⲿRAMĴݻ,Ϊһĳ */
UINT8	DISK_BASE_BUF[ DISK_BASE_BUF_LEN ] __attribute__((aligned (4)));	/* ⲿRAMĴݻ,Ϊһĳ */
//UINT8	DISK_FAT_BUF[ DISK_BASE_BUF_LEN ] __attribute__((aligned (4)));	/* ⲿRAMĴFATݻ,Ϊһĳ */
#endif

/* ³ԸҪ޸ */
#ifndef	NO_DEFAULT_ACCESS_SECTOR		/* ӦóжNO_DEFAULT_ACCESS_SECTORԽֹĬϵĴдӳ,Ȼбдĳ */
//if ( use_external_interface ) // 滻Uײдӳ
//{
//    CHRV3vSectorSize=512;     // ʵʵС,512ı,ֵǴ̵С
//    CHRV3vSectorSizeB=9;      // ʵʵСλ,512Ӧ9,1024Ӧ10,2048Ӧ11
//    CHRV3DiskStatus=DISK_MOUNTED;  // ǿƿ豸ӳɹ(ֻļϵͳ)
//}

UINT8	CHRV3ReadSector( UINT8 SectCount, PUINT8 DataBuf )  /* Ӵ̶ȡݵ */
{
	UINT8	retry;
//	if ( use_external_interface ) return( extReadSector( CHRV3vLbaCurrent, SectCount, DataBuf ) );  /* ⲿӿ */
	for( retry = 0; retry < 3; retry ++ ) {  /*  */
		pCBW -> mCBW_DataLen = (UINT32)SectCount << CHRV3vSectorSizeB;  /* ݴ䳤 */
		pCBW -> mCBW_Flag = 0x80;
		pCBW -> mCBW_LUN = CHRV3vCurrentLun;
		pCBW -> mCBW_CB_Len = 10;
		pCBW -> mCBW_CB_Buf[ 0 ] = SPC_CMD_READ10;
		pCBW -> mCBW_CB_Buf[ 1 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 2 ] = (UINT8)( CHRV3vLbaCurrent >> 24 );
		pCBW -> mCBW_CB_Buf[ 3 ] = (UINT8)( CHRV3vLbaCurrent >> 16 );
		pCBW -> mCBW_CB_Buf[ 4 ] = (UINT8)( CHRV3vLbaCurrent >> 8 );
		pCBW -> mCBW_CB_Buf[ 5 ] = (UINT8)( CHRV3vLbaCurrent );
		pCBW -> mCBW_CB_Buf[ 6 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 7 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 8 ] = SectCount;
		pCBW -> mCBW_CB_Buf[ 9 ] = 0x00;
		CHRV3BulkOnlyCmd( DataBuf );  /* ִлBulkOnlyЭ */
		if ( CHRV3IntStatus == ERR_SUCCESS ) {
			return( ERR_SUCCESS );
		}
		CHRV3IntStatus = CHRV3AnalyzeError( retry );
		if ( CHRV3IntStatus != ERR_SUCCESS ) {
			return( CHRV3IntStatus );
		}
	}
	return( CHRV3IntStatus = ERR_USB_DISK_ERR );  /* ̲ */
}

#ifdef	EN_DISK_WRITE
UINT8	CHRV3WriteSector( UINT8 SectCount, PUINT8 DataBuf )  /* еĶݿд */
{
	UINT8	retry;
//	if ( use_external_interface ) return( extWriteSector( CHRV3vLbaCurrent, SectCount, DataBuf ) );  /* ⲿӿ */
	for( retry = 0; retry < 3; retry ++ ) {  /*  */
		pCBW -> mCBW_DataLen = (UINT32)SectCount << CHRV3vSectorSizeB;  /* ݴ䳤 */
		pCBW -> mCBW_Flag = 0x00;
		pCBW -> mCBW_LUN = CHRV3vCurrentLun;
		pCBW -> mCBW_CB_Len = 10;
		pCBW -> mCBW_CB_Buf[ 0 ] = SPC_CMD_WRITE10;
		pCBW -> mCBW_CB_Buf[ 1 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 2 ] = (UINT8)( CHRV3vLbaCurrent >> 24 );
		pCBW -> mCBW_CB_Buf[ 3 ] = (UINT8)( CHRV3vLbaCurrent >> 16 );
		pCBW -> mCBW_CB_Buf[ 4 ] = (UINT8)( CHRV3vLbaCurrent >> 8 );
		pCBW -> mCBW_CB_Buf[ 5 ] = (UINT8)( CHRV3vLbaCurrent );
		pCBW -> mCBW_CB_Buf[ 6 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 7 ] = 0x00;
		pCBW -> mCBW_CB_Buf[ 8 ] = SectCount;
		pCBW -> mCBW_CB_Buf[ 9 ] = 0x00;
		CHRV3BulkOnlyCmd( DataBuf );  /* ִлBulkOnlyЭ */
		if ( CHRV3IntStatus == ERR_SUCCESS ) {
			Delay_Us( 200 );  /* дʱ */
			return( ERR_SUCCESS );
		}
		CHRV3IntStatus = CHRV3AnalyzeError( retry );
		if ( CHRV3IntStatus != ERR_SUCCESS ) {
			return( CHRV3IntStatus );
		}
	}
	return( CHRV3IntStatus = ERR_USB_DISK_ERR );  /* ̲ */
}
#endif
#endif  // NO_DEFAULT_ACCESS_SECTOR

#ifndef	NO_DEFAULT_DISK_CONNECT			/* ӦóжNO_DEFAULT_DISK_CONNECTԽֹĬϵļӳ,Ȼбдĳ */

/*
Լ: USB豸ַ(οUSB_DEVICE_ADDR)
ֵַ  豸λ
0x02    Root-HUB0µUSB豸ⲿHUB
0x03    Root-HUB1µUSB豸ⲿHUB
0x1x    Root-HUB0µⲿHUBĶ˿xµUSB豸,xΪ1~n
0x2x    Root-HUB1µⲿHUBĶ˿xµUSB豸,xΪ1~n
*/

#define		UHUB_DEV_ADDR	R8_USB_DEV_AD
#define		UHUB_MIS_STAT	R8_USB_MIS_ST
#define		UHUB_HOST_CTRL	R8_UHOST_CTRL
#define		UHUB_INT_FLAG	R8_USB_INT_FG
#define		bUMS_ATTACH		RB_UMS_DEV_ATTACH
#define		bUMS_SUSPEND	RB_UMS_SUSPEND

/* Ƿ */
UINT8 CHRV3DiskConnect( void )
{
	UINT8	ums, devaddr;
	UHUB_DEV_ADDR = UHUB_DEV_ADDR & 0x7F;
	ums = UHUB_MIS_STAT;
	devaddr = UHUB_DEV_ADDR;
	if ( devaddr == USB_DEVICE_ADDR )
	{  /* Root-HUBµUSB豸 */
		if ( ums & bUMS_ATTACH )
		{  /* Root-HUBµUSB豸 */
			if ( ( ums & bUMS_SUSPEND ) == 0 )
			{
			    /* Root-HUBµUSB豸δ */
				return( ERR_SUCCESS );  /* USB豸Ѿδ */
			}
			else
			{  /* Root-HUBµUSB豸 */
//mDiskConnect:
				CHRV3DiskStatus = DISK_CONNECT;  /* Ͽ */
				return( ERR_SUCCESS );  /* ⲿHUBUSB豸Ѿӻ߶Ͽ */
			}
		}
		else
		{
		    /* USB豸Ͽ */
mDiskDisconn:
			CHRV3DiskStatus = DISK_DISCONNECT;
			return( ERR_USB_DISCON );
		}
	}
	else
	{
		goto mDiskDisconn;
	}
}
#endif  // NO_DEFAULT_DISK_CONNECT

#ifndef	NO_DEFAULT_FILE_ENUMER			/* ӦóжNO_DEFAULT_FILE_ENUMERԽֹĬϵļöٻص,Ȼбдĳ */
void xFileNameEnumer( void )			/* ļöٻصӳ */
{
/* ָöCHRV3vFileSizeΪ0xFFFFFFFFFileOpenôÿһļFileOpenñص
   صxFileNameEnumerغFileOpenݼCHRV3vFileSizeöֱļĿ¼ǣ
   ڵFileOpen֮ǰһȫֱΪ0FileOpenص󣬱CHRV3vFdtOffsetõṹFAT_DIR_INFO
   ṹеDIR_AttrԼDIR_NameжǷΪļĿ¼¼Ϣȫֱ
   FileOpenغжϷֵERR_MISS_FILEERR_FOUND_NAMEΪɹȫֱΪЧļ
   ڱصxFileNameEnumerнCHRV3vFileSizeΪ1ô֪ͨFileOpenǰǻص */
#if		0
	UINT8			i;
	UINT16			FileCount;
	PX_FAT_DIR_INFO	pFileDir;
	PUINT8			NameBuf;
	pFileDir = (PX_FAT_DIR_INFO)( pDISK_BASE_BUF + CHRV3vFdtOffset );  /* ǰFDTʼַ */
	FileCount = (UINT16)( 0xFFFFFFFF - CHRV3vFileSize );  /* ǰļö,CHRV3vFileSizeֵ0xFFFFFFFF,ҵļݼ */
	if ( FileCount < sizeof( FILE_DATA_BUF ) / 12 ) {  /* 黺Ƿ㹻,ٶÿļռ12ֽڴ */
		NameBuf = & FILE_DATA_BUF[ FileCount * 12 ];  /* 㱣浱ǰļĻַ */
		for ( i = 0; i < 11; i ++ ) NameBuf[ i ] = pFileDir -> DIR_Name[ i ];  /* ļ,Ϊ11ַ,δո */
//		if ( pFileDir -> DIR_Attr & ATTR_DIRECTORY ) NameBuf[ i ] = 1;  /* жĿ¼ */
		NameBuf[ i ] = 0;  /* ļ */
	}
#endif
}
#endif  // NO_DEFAULT_FILE_ENUMER

UINT8	CHRV3LibInit( void )  /* ʼCHRV3,ɹ0 */
{
	if ( CHRV3GetVer( ) < CHRV3_LIB_VER ) return( 0xFF );  /* ȡǰӳİ汾,汾̫򷵻ش */
#if		DISK_BASE_BUF_LEN > 0
	pDISK_BASE_BUF = & DISK_BASE_BUF[0];  /* ָⲿRAMĴݻ */
	pDISK_FAT_BUF = & DISK_BASE_BUF[0];  /* ָⲿRAMĴFATݻ,pDISK_BASE_BUFԽԼRAM */
//	pDISK_FAT_BUF = & DISK_FAT_BUF[0];  /* ָⲿRAMĴFATݻ,pDISK_BASE_BUFٶ */
/* ϣļȡٶ,ôеCHRV3LibInit֮,pDISK_FAT_BUFָһpDISK_BASE_BUFͬСĻ */
#endif
	CHRV3DiskStatus = DISK_UNKNOWN;  /* δ֪״̬ */
	CHRV3vSectorSizeB = 9;  /* Ĭϵ̵512B */
	CHRV3vSectorSize = 512;  // Ĭϵ̵512B,ֵǴ̵С
	CHRV3vStartLba = 0;  /* ĬΪԶFDDHDD */
	CHRV3vPacketSize = 64;  /* USB洢豸:64@FS,512@HS/SS,Ӧóʼ,öU̺Ǹٻ߳ôʱΪ512 */
	pTX_DMA_A_REG = (PUINT32)&R16_UH_TX_DMA;  /* ָDMAַĴ,Ӧóʼ */
	pRX_DMA_A_REG = (PUINT32)&R16_UH_RX_DMA;  /* ָDMAַĴ,Ӧóʼ */
	pTX_LEN_REG = (PUINT16)&R8_UH_TX_LEN;  /* ָͳȼĴ,Ӧóʼ */
	pRX_LEN_REG = (PUINT16)&R16_USB_RX_LEN;  /* ָճȼĴ,Ӧóʼ */

//CHRV3vRootPort = 0;  /* USBѡ(Root-hubѡ˿) */
	return( ERR_SUCCESS );
}

void mDelaymS( UINT16 n )
{
	Delay_Ms(n);
}

